"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var util = __importStar(require("../util"));
var decode = function (msg) {
    var paths = util.searchAll(msg, "instantiatedPath");
    if (paths && paths.length === 1)
        return [paths[0]];
    return [paths];
};
var isObj = function (v) {
    return typeof v === "object" && v.required !== undefined && v.value !== undefined;
};
var makePair = function (value) {
    return value
        ? Object.entries(value).map(function (_a) {
            var k = _a[0], v = _a[1];
            return isObj(v)
                ? [k, v.value.toString(), "required" in v && Boolean(v.required)]
                : [k, v.toString(), true];
        })
        : [];
};
var encode = function (_a) {
    var value = _a.value, path = _a.path;
    var paths = Array.isArray(path) ? path : [path];
    var values = value ? (Array.isArray(value) ? value : [value]) : [];
    var allowPartial = values && values.some(function (it) { return it.allowPartial; }) || false;
    var createObjs = paths.map(function (path, i) { return ({
        lookup: "Add.CreateObject",
        objPath: path,
        paramSettings: makePair(values[i])
            .filter(function (_a) {
            var k = _a[0];
            return k !== "allowPartial";
        })
            .map(function (_a) {
            var param = _a[0], value = _a[1], required = _a[2];
            return ({
                lookup: "Add.CreateParamSetting",
                param: param,
                value: value,
                required: required,
            });
        }),
    }); });
    return {
        lookup: "Msg",
        header: {
            lookup: "Header",
            msgId: util.uniq("ADD@"),
            msgType: "ADD",
        },
        body: {
            lookup: "Body",
            request: {
                lookup: "Request",
                add: {
                    allowPartial: allowPartial,
                    createObjs: createObjs,
                },
            },
        },
    };
};
exports.default = {
    decode: decode,
    encode: encode,
};
