"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("../util");
var operateSubscriptionPath = "Device.LocalAgent.Subscription.";
var make = function (call, on) {
    return function (path, opts) { return __awaiter(void 0, void 0, void 0, function () {
        var Persistent, isAsync, id, operateInput, commandKey, command, newSubPath_1, cleanup;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    Persistent = (opts === null || opts === void 0 ? void 0 : opts.Persistent) === undefined ? false : opts.Persistent;
                    isAsync = !(opts && opts.isAsync === false);
                    id = (isAsync ? "NOTIFY@" : "OPERATE@") + ((opts === null || opts === void 0 ? void 0 : opts.ID) || util_1.uniq(path));
                    operateInput = {
                        Enable: true,
                        ID: id,
                        NotifType: "OperationComplete",
                        ReferenceList: path,
                        Persistent: Persistent,
                    };
                    commandKey = (opts === null || opts === void 0 ? void 0 : opts.commandKey) || "";
                    command = function (input) {
                        var _a;
                        return call("OPERATE", {
                            path: path,
                            input: input,
                            id: id,
                            resp: (_a = opts === null || opts === void 0 ? void 0 : opts.sendResponse) !== null && _a !== void 0 ? _a : true,
                            commandKey: commandKey,
                        }, isAsync ? { responseMsgType: "NOTIFY" } : {});
                    };
                    command.subscribe = function (cb, opts) {
                        var _a;
                        var skipOperateResponse = (_a = opts === null || opts === void 0 ? void 0 : opts.skipOperateResponse) !== null && _a !== void 0 ? _a : true;
                        var handleCallback = function (msg) {
                            if (skipOperateResponse &&
                                typeof msg === "object" &&
                                "executedCommand" in msg)
                                return;
                            else
                                cb(msg);
                        };
                        on(id, handleCallback);
                        return {
                            trigger: command,
                        };
                    };
                    if (!isAsync) return [3 /*break*/, 2];
                    return [4 /*yield*/, call("ADD", {
                            path: operateSubscriptionPath,
                            value: operateInput,
                        })];
                case 1:
                    newSubPath_1 = _a.sent();
                    cleanup = function () {
                        return call("DELETE", { paths: newSubPath_1 });
                    };
                    return [2 /*return*/, [command, cleanup]];
                case 2: return [2 /*return*/, [command, function () { return Promise.resolve(); }]];
            }
        });
    }); };
};
exports.default = {
    name: "operate",
    make: make,
};
