"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResponseType = exports.processGetResult = exports.parseID = exports.uniq = exports.makeBuffer = exports.isEmpty = exports.isEmptyObject = exports.unwrapArray = exports.unwrapObject = exports.extractCommand = exports.searchAll = exports.hasMultipleIndexes = exports.convertToNestedObject = exports.searchParent = exports.search = exports.unflatten = exports.isDigit = void 0;
// import set from "lodash.set";
var digitDotRe = /^\d+\..*$/;
var digitRe = /^\d+$/;
var isDigit = function (v) { return digitRe.test(v); };
exports.isDigit = isDigit;
var firstIsIndex = function (s) { return digitDotRe.test(s); };
// based on https://stackoverflow.com/questions/54733539/javascript-implementation-of-lodash-set-method
var set = function (obj, path, value) {
    if (Object(obj) !== obj)
        return obj;
    if (!Array.isArray(path))
        path = path.toString().match(/[^.[\]]+/g) || [];
    path
        .slice(0, -1)
        .reduce(function (a, c, i) {
        return Object(a[c]) === a[c]
            ? a[c]
            : (a[c] = Math.abs(path[i + 1]) >> 0 === +path[i + 1] ? [] : {});
    }, obj)[path[path.length - 1]] = value;
    return obj;
};
// Based on: https://www.30secondsofcode.org/js/s/unflatten-object
var unflatten = function (obj) {
    return Object.keys(obj).reduce(function (res, k) {
        k.split(".")
            .map(function (v) { return (exports.isDigit(v) ? parseInt(v) - 1 : v); })
            .reduce(function (acc, e, i, keys) {
            return acc[e] ||
                (acc[e] = isNaN(Number(keys[i + 1]))
                    ? keys.length - 1 === i
                        ? obj[k]
                        : {}
                    : []);
        }, res);
        return res;
    }, firstIsIndex(Object.keys(obj)[0]) ? [] : {});
};
exports.unflatten = unflatten;
var search = function (obj, key) {
    if (typeof obj !== "object")
        return null;
    if (obj[key])
        return obj[key];
    for (var _i = 0, _a = Object.values(obj); _i < _a.length; _i++) {
        var val = _a[_i];
        var s = exports.search(val, key);
        if (s)
            return s;
    }
};
exports.search = search;
var searchParent = function (obj, key) {
    if (typeof obj !== "object")
        return;
    if (obj[key])
        return obj;
    for (var _i = 0, _a = Object.values(obj); _i < _a.length; _i++) {
        var val = _a[_i];
        var s = exports.searchParent(val, key);
        if (s)
            return s;
    }
};
exports.searchParent = searchParent;
var fixPath = function (s) {
    return s
        .split(".")
        .filter(function (it) { return it !== ""; })
        .map(function (it) { return (exports.isDigit(it) ? "[" + (parseInt(it) - 1) + "]" : it); })
        .join(".")
        .split(".[")
        .join("[");
};
var convertToNestedObject = function (arr) {
    var res = {};
    arr
        .map(function (it) {
        return Object.entries(it.resultParams).map(function (_a) {
            var key = _a[0], value = _a[1];
            return ({
                path: fixPath(it.resolvedPath + key),
                value: value,
            });
        });
    })
        .flat(1)
        .sort(function (a, b) { return a.path.localeCompare(b.path); })
        .forEach(function (_a) {
        var path = _a.path, value = _a.value;
        set(res, path, value);
    });
    return res;
};
exports.convertToNestedObject = convertToNestedObject;
var hasMultipleIndexes = function (arr, pathSplit) {
    return arr.some(function (it) {
        var spl = it.split(".");
        return spl.length > pathSplit.length && exports.isDigit(spl[pathSplit.length - 1]);
    });
};
exports.hasMultipleIndexes = hasMultipleIndexes;
var _searchAll = function (obj, key) {
    return typeof obj !== "object"
        ? []
        : Object.entries(obj).reduce(function (acc, _a) {
            var k = _a[0], v = _a[1];
            return __spreadArray(__spreadArray([], acc), [k === key ? v : _searchAll(v, key)]);
        }, []);
};
var searchAll = function (obj, key) {
    return _searchAll(obj, key).flat(Infinity);
};
exports.searchAll = searchAll;
var extractCommand = function (msg) {
    var msgType = exports.search(msg, "msgType");
    if (!msgType) {
        var id = exports.search(msg, "msgId");
        var frst = (id ? id.split("@") : [""])[0];
        return frst.toUpperCase().replace("_RESP", "");
    }
    return msgType.replace("_RESP", "");
};
exports.extractCommand = extractCommand;
/** Unwraps object with single key */
var unwrapObject = function (data) {
    return !Array.isArray(data) &&
        typeof data === "object" &&
        Object.keys(data).length === 1
        ? Object.values(data)[0]
        : data;
};
exports.unwrapObject = unwrapObject;
/** Unwraps array with single item */
var unwrapArray = function (arr) {
    return Array.isArray(arr) && arr.length === 1 ? arr[0] : arr;
};
exports.unwrapArray = unwrapArray;
var isEmptyObject = function (obj) {
    return obj !== null &&
        obj !== undefined &&
        obj &&
        typeof obj === "object" &&
        Object.keys(obj).length === 0;
};
exports.isEmptyObject = isEmptyObject;
var isEmpty = function (v) { return exports.isEmptyObject(v); };
exports.isEmpty = isEmpty;
function makeBuffer(rootRecord, payload, version, options, sessionOptions, useSession) {
    var contextRecord = rootRecord.lookupType("usp_record." + (useSession ? "" : "No") + "SessionContextRecord");
    var contextRecordMsg = contextRecord.create(__assign({ payload: useSession ? [payload] : payload }, (useSession ? sessionOptions : {})));
    var record = rootRecord.lookupType("usp_record.Record");
    var recordMsg = record.create(__assign(__assign({ version: version, PayloadSecurity: record.PayloadSecurity.PLAINTEXT }, (useSession
        ? { sessionContext: contextRecordMsg }
        : { noSessionContext: contextRecordMsg })), options));
    var buffer = record.encode(recordMsg).finish();
    return buffer;
}
exports.makeBuffer = makeBuffer;
var uniq = function (initial) {
    return (initial || "") +
        (Date.now().toString(36) + Math.random().toString(36).substr(2, 5)).toUpperCase();
};
exports.uniq = uniq;
var parseID = function (msg) {
    var foundId = exports.search(msg, "msgId");
    // if id is formatted by me (command@) then use, otherwise check for sub id
    var id = foundId.includes("@")
        ? foundId
        : exports.search(msg, "subscriptionId") || null;
    return id;
};
exports.parseID = parseID;
var grab = function (item, key) {
    return Array.isArray(item)
        ? exports.isDigit(key)
            ? item.find(function (val) { return val !== null && val !== undefined; })
            : item
        : key === "-1"
            ? item.find(function (v) { return v !== null; })
            : item[key];
};
var skipKeys = function (obj, keys) {
    return keys.length === 1
        ? grab(obj, keys[0])
        : skipKeys(grab(obj, keys[0]), keys.slice(1));
};
var removeNulls = function (obj) {
    return typeof obj !== "object"
        ? obj
        : Array.isArray(obj)
            ? obj.filter(function (v) { return v !== null; }).map(removeNulls)
            : Object.entries(obj).reduce(function (acc, _a) {
                var _b;
                var key = _a[0], value = _a[1];
                return (__assign((_b = {}, _b[key] = Array.isArray(value)
                    ? value.filter(function (v) { return v !== null; }).map(removeNulls)
                    : removeNulls(value), _b), acc));
            }, {});
};
var pathJoin = function (a, b) {
    return a.endsWith(".") ? a + b : a + "." + b;
};
var cutQueryElements = function (path) {
    return path
        .split(/\[.*\]./)
        .join("")
        .split(/\*\./)
        .join("");
};
var addQueries = function (obj, path) {
    return typeof obj !== "object"
        ? obj
        : Array.isArray(obj)
            ? obj
                .map(function (v, i) {
                return v === null
                    ? null
                    : addQueries(v, pathJoin(path, (i + 1).toString()) + ".");
            })
                .filter(function (v) { return v !== null; })
            : __assign({ __query__: cutQueryElements(path) }, Object.entries(obj).reduce(function (acc, _a) {
                var _b;
                var key = _a[0], val = _a[1];
                return (__assign(__assign({}, acc), (_b = {}, _b[key] = typeof val !== "object"
                    ? val
                    : addQueries(val, pathJoin(path, key) + "."), _b)));
            }, {}));
};
var processGetResult = function (reqPathResults, decodeOptions) {
    var retainPath = (decodeOptions === null || decodeOptions === void 0 ? void 0 : decodeOptions.retainPath) === true;
    var results = reqPathResults.map(function (resolvedResult) {
        var respType = determineResponseType(resolvedResult);
        if (resolvedResult.resolvedPathResults === undefined)
            return null;
        var results = resolvedResult.resolvedPathResults || [];
        if (respType === ResponseType.Property) {
            var result = Object.values(results[0].resultParams)[0];
            return !retainPath
                ? result
                : { __query__: resolvedResult.requestedPath, result: result };
        }
        if (respType === ResponseType.PropertyList) {
            var result = results.map(function (result) { return Object.values(result.resultParams)[0]; });
            return !retainPath
                ? result
                : {
                    __query__: resolvedResult.requestedPath,
                    result: result.map(function (str, i) { return ({
                        __query__: results[i].resolvedPath +
                            Object.keys(results[i].resultParams)[0],
                        result: str,
                    }); }),
                };
        }
        if (respType === ResponseType.Object ||
            respType === ResponseType.ObjectList) {
            var path = resolvedResult.requestedPath;
            var keys = path.split(".").slice(0, -1);
            var nestedObject = exports.convertToNestedObject(results);
            var mainObject = skipKeys(nestedObject, keys);
            var cleanedObject = removeNulls(mainObject);
            return !retainPath
                ? cleanedObject
                : {
                    __query__: path,
                    result: addQueries(mainObject, path),
                };
        }
        return null;
    });
    return results.length === 1 ? results[0] : results;
};
exports.processGetResult = processGetResult;
var ResponseType;
(function (ResponseType) {
    ResponseType["Property"] = "Property";
    ResponseType["PropertyList"] = "PropertyList";
    ResponseType["Object"] = "Object";
    ResponseType["ObjectList"] = "ObjectList";
})(ResponseType = exports.ResponseType || (exports.ResponseType = {}));
var containsQuery = function (path) {
    return path.split(".").some(function (part) { return part.includes("*") || part.includes("["); });
};
var endsWithProperty = function (path) {
    return /^.+\.[A-Za-z0-9]+$/.test(path);
};
var endsWithIndex = function (path) { return /^.+\.\d+\.$/.test(path); };
var endsWithIndexedProperty = function (path) {
    return /^.+\.\d+\..+$/.test(path.split(".").slice(-2)[0]);
};
var containsIndexes = function (pathResult) {
    return pathResult.resolvedPathResults === undefined
        ? false
        : pathResult.resolvedPathResults.some(function (_a) {
            var resolvedPath = _a.resolvedPath, resultParams = _a.resultParams;
            return (endsWithIndex(resolvedPath) &&
                resolvedPath.split(".").length ===
                    pathResult.requestedPath.split(".").length + 1) ||
                Object.keys(resultParams).some(function (key) {
                    return endsWithIndexedProperty(pathResult.requestedPath + key);
                });
        });
};
var determineResponseType = function (pathResult) {
    var isQuery = containsQuery(pathResult.requestedPath);
    if (endsWithProperty(pathResult.requestedPath))
        return isQuery ? ResponseType.PropertyList : ResponseType.Property;
    if (isQuery || containsIndexes(pathResult))
        return ResponseType.ObjectList;
    if (endsWithIndex(pathResult.requestedPath))
        return ResponseType.Object;
    return ResponseType.Object;
};
