"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var os = __importStar(require("os"));
var std = __importStar(require("std"));
var websocket_js_1 = require("/usr/lib/quickjs/websocket.js");
var AsyncClient = /** @class */ (function () {
    function AsyncClient() {
        globalThis.WebSocket = websocket_js_1.WebSocket;
        // paho-mqtt requires setTimeout and clearTimeout in global scope
        globalThis.setTimeout = os.setTimeout;
        globalThis.clearTimeout = function (timeout) {
            if (timeout) {
                os.clearTimeout(timeout);
            }
        };
        globalThis.global = globalThis;
        std.loadScript("/usr/lib/usp-js/lib/protobuf.min.js");
        std.loadScript("/usr/lib/usp-js/lib/paho-mqtt.min.js");
        protobuf.Root.prototype.fetch = function (filename, callback) {
            os.setTimeout(function () {
                var data = std.loadFile(filename);
                if (data === null)
                    callback(new Error("failed to load file: " + filename));
                else
                    callback(null, data);
            }, 0);
        };
    }
    AsyncClient.prototype.connectAsync = function (host, port, user, password, clientId) {
        if (host === void 0) { host = "localhost"; }
        if (port === void 0) { port = 9001; }
        if (user === void 0) { user = "admin"; }
        if (password === void 0) { password = "admin"; }
        if (clientId === void 0) { clientId = "qjs_client"; }
        return __awaiter(this, void 0, void 0, function () {
            var opts, client, connectPromise, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.client = new Paho.Client(host, port, "/mqtt", clientId);
                        opts = {
                            userName: user,
                            password: password,
                        };
                        client = this.client;
                        connectPromise = new Promise(function (resolve, reject) {
                            opts.onFailure = function (err) {
                                reject(new Error(err.errorMessage));
                            };
                            opts.onSuccess = function () {
                                resolve(client);
                            };
                            client.connect(opts);
                        });
                        _a = this;
                        return [4 /*yield*/, connectPromise];
                    case 1:
                        _a.client = _b.sent();
                        // this.client.subscribe('/usp/controller/#')
                        return [2 /*return*/, this];
                }
            });
        });
    };
    AsyncClient.prototype.subscribe = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.client.subscribe(id);
                return [2 /*return*/];
            });
        });
    };
    AsyncClient.prototype.unsubscribe = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.client.unsubscribe(id);
                return [2 /*return*/];
            });
        });
    };
    AsyncClient.prototype.on = function (msg, callback) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (msg === "message") {
                    this.client.onMessageArrived = function (msg) {
                        callback(msg.payloadBytes);
                    };
                }
                else if (msg === "error") {
                    // there is no erro handling in paho mqtt
                    this.client.onConnectionLost = function (responseObject) {
                        callback(responseObject);
                    };
                }
                return [2 /*return*/];
            });
        });
    };
    AsyncClient.prototype.publish = function (topic, msg) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.client.send(topic, msg);
                return [2 /*return*/];
            });
        });
    };
    AsyncClient.prototype.end = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.client.disconnect();
                return [2 /*return*/];
            });
        });
    };
    return AsyncClient;
}());
function main() {
    return __awaiter(this, void 0, void 0, function () {
        var client;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    client = new AsyncClient();
                    return [4 /*yield*/, client.connect()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
var mqttAsync = new AsyncClient();
exports.default = mqttAsync;
