"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.knownUSPVersions = exports.parseCallbackOptions = exports.makeCallbackRouter = exports.makeRouter = void 0;
var util_1 = require("./commands/util");
/**
 * Makes a router for storing resolve/reject for a message
 */
var makeRouter = function () {
    var routes = new Map();
    return {
        get: function (id, cmd) {
            var res = __assign({}, routes.get(id + "--" + cmd));
            routes.delete(id);
            return res;
        },
        add: function (id, cmd, data) {
            routes.set(id + "--" + cmd, __assign({}, data));
        },
    };
};
exports.makeRouter = makeRouter;
var toId = function (id) { return id.toString(); };
var isRegExp = function (v) { return typeof v === "object"; };
var satisfies = function (id, matches) {
    return isRegExp(id) ? matches.match(id) !== null : id === matches;
};
var makeCallbackRouter = function () {
    var routes = new Map();
    return {
        get: function (id) {
            return Array.from(routes.values())
                .filter(function (_a) {
                var ident = _a.ident;
                return satisfies(ident, id);
            })
                .map(function (v) { return v.callback; });
        },
        add: function (ident, callback) {
            routes.set(toId(ident), { callback: callback, ident: ident });
        },
        del: function (id) { return routes.delete(toId(id)); },
    };
};
exports.makeCallbackRouter = makeCallbackRouter;
var parseCallbackOptions = function (msg) {
    var sendResp = util_1.search(msg, "sendResp");
    if (typeof sendResp === "boolean")
        return { sendResp: sendResp };
    return null;
};
exports.parseCallbackOptions = parseCallbackOptions;
exports.knownUSPVersions = ["1.0", "1.1", "1.2"];
