import { CommandType, CallFn, OnFn, DecodeResponse, Proto, DecodeOptions, USPVersion, USPSession } from "../types";
export declare const makeRecipes: (call: CallFn, on: OnFn) => any;
export declare const decodeId: (data: any) => string;
export declare const decodeRecord: (proto: Proto, data: any) => Record<string, any>;
export declare const readMsg: (proto: Proto, data: any) => [Record<string, any>, unknown, boolean];
declare type DecodeFn = (parsedMsg: any, version: USPVersion) => DecodeResponse;
export declare const decode: DecodeFn;
declare type DecodeWithOptionsFn = (parsedMsg: any, cmdType: CommandType | undefined, options: DecodeOptions, version: USPVersion) => any;
export declare const decodeWithOptions: DecodeWithOptionsFn;
export declare const makeEmptySessionMessage: (proto: Proto, bufferOptions: Record<string, string>, sessionOptions: USPSession, version: USPVersion, useSession: boolean) => any;
export declare const makeEncode: (proto: Proto, bufferOptions: Record<string, string>, useSession: boolean) => (command: CommandType, version: USPVersion, args: Record<string, any>, sessionOptions: USPSession) => [string, any, string | null];
export declare const makeSession: (sessionId: number | null) => USPSession;
export declare const hasSessionDisconnectError: (msg: Record<string, any>) => boolean;
export declare const msgLacksPayload: (msg: Record<string, any>) => boolean;
export {};
